class Chunk

  C_BEGIN = 'B'
  C_END   = 'E'
  IN    = 'I'
  SINGLE = "S"
  OTHER  = "O"

  attr_accessor :label, :score, :boundary

  def initialize() 
    @boundary = nil  
    @label    = nil
    @score    = 0.0
  end

  def to_s
    return @boundary if other? || @label == nil 
    return "%s-%s" % [@boundary, @label]
  end

  def empty?
    return @label == nil && @boundary == nil 
  end

  def other?
    return @boundary == OTHER
  end

  def begin?
    return @boundary == C_BEGIN
  end
  
  def end?
    return @boundary == C_END
  end

  def in?
    return @boundary == IN
  end

  def single?
    return @boundary == SINGLE
  end
end
