require 'sentence'

class Parser

  class BOS < Exception ; end 
  class EOS < Exception ; end 
  class Complete < Exception ; end
  class Fail < Exception ; end

  FORWARD = 1
  BACKWARD = -1

  attr_accessor :current, :sentence, :model, :feature_extractor, :current, :default_lc_length, :default_rc_length 
  attr_reader :direction, :parsetree, :target 

  def initialize() 
    @model = nil 

    @left_context  = nil 
    @right_context = nil 
    @target = nil
    @direction = FORWARD.to_i
    @current = 0
    @features = []
    @history = []
    @sentence = nil
    @parsetree = nil 
    @actions = nil
    @feature_extractor = nil 
    # @grouping_method = nil 
    @construction = false
    @default_lc_length = 2
    @default_rc_length = 2
  end

  def no_construction?
    return ! @construction 
  end

  def reset_construction_cheker
    @construction = false
  end

  def view_status
  end

  def show_result(os=$stdout)
  end

  def to_s
  end

  def set_model(model)
    @model = model
  end

  def set_sentence(_sentence)
    @sentence = _sentence
  end

  def parse(lc=2, rc=2, _model=@model)

    @left_context, @target, @right_context = @sentence.get_context(@current, 1, lc, rc)
    @features = get_features
    @actions = estimate
    construct
    
  end

  def get_features(left=@left_context, center=@target, right=@right_context)
  end

  def estimate
  end

  def construct
  end

  def clear
  end

  def shift
    @current += @direction
  end

  def reduce
  end

  def forward
    @direction = FORWARD.to_i
  end

  def backward
    @direction = BACKWARD.to_i
  end

  def forward?
    return @direction > 0
  end

  def backward?
    return @direction < 0
  end

  def go_to_bos
    @current = 0 
  end

  def go_to_eos
    @current = @sentence.size - 1 
  end
  
end

if __FILE__ == $0
end


