#!/usr/local/bin/ruby

class Sentence < Array
  def initialize(_type) 
    @element_type = _type
    super()
  end

  def [](*arg)

    if arg.size == 0
      super(arg)
      return 
    end
    if arg.size > 1
      return super(arg)
    end
   
    if arg[0] < 0
      return @element_type.bos
    end

    if arg[0] >= self.size
      return @element_type.eos
    end

    return super(arg[0])
  end

  def get_context(c, c_length, l_length, r_length,  l=c, r=c+c_length)
    return get_left_context(l, l_length), get_center(c, c_length),  get_right_context(r, r_length)
  end

  def get_center(c, length)
    if length < 0
      return get_left_context(c, length)
    elsif length > 0
      return get_right_context(c, length)
    end
    return [self[c]]
  end

  def get_left_context(point, length)
    s = point - length.abs
    out = [] 
    (s ... point).each do |i| 
      out << self[i]
    end
    return out
  end

  def get_right_context(point, length)
    e = point + length.abs
    out = [] 
    (point ... e).each do |i| 
      out << self[i]
    end
    return out
  end
  
end

if __FILE__ == $0
end


