module TreeConvertor

  def str2tree(str, bp)
    tokens = bp.str2tokens(str)
    return bp.parse(tokens)
  end

  def head_find(tree, hf)
    # puts "check"

    # tree.depth_first_traverse_pre_order do |node|
    tree.depth_first_traverse_post_order do |node|
      #puts node
      # puts hf[node.label]
      hid = hf.find(node.label, node.children)
      # puts hid 
      # puts 
      # node.head = hid if node.head == nil 
      node.head = hid
      unless node.offset 
	node.offset = node.head_offset
      end
    end
    return tree
  end

  def tree2cfg(tree, non_terminal, pre_terminal, terminal)
    cfg = [] 
    tree.depth_first_traverse_pre_order do |node|
      rule =  node.to_cfg_rule
      cfg << rule if rule
    end
    return cfg
  end

  def tree2lcfg(tree, non_terminal, pre_terminal, terminal)

    tree.depth_first_traverse_pre_order do |node|
      next if node.leaf?
      cfg = [] 
      # p node.to_s
      # p node.type
      cfg << node.label.to_s
      
      left = []
      right = [] 
      # puts '=== %s %s ' % [node.head, node.children.size ]
      h = node.children[node.head]
      node.children.each do |x|
	left << x if x.offset < h.offset
	right << x if x.offset > h.offset
      end

      i = left.size 
      left.sort{|a, b| a.offset <=> b.offset}.each do |x|
	cfg << "-%s.label.%s:1" % [i, x.label] if x.label
	cfg << "-%s.lex.%s:1" % [i, x.head_word]
	cfg << "-%s.pos.%s:1" % [i, x.head_pos]
	i -= 1
      end
      cfg << "0.label.%s:1" % [h.label] if h.label
      cfg << "0.lex.%s:1" % [h.head_word]
      cfg << "0.pos.%s:1" % [h.head_pos]
      
      i = 1 
      right.sort{|a, b| a.offset <=> b.offset}.each do |x|
	cfg << "+%s.label.%s:1" % [i, x.label] if x.label
	cfg << "+%s.lex.%s:1" % [i, x.head_word]
	cfg << "+%s.pos.%s:1" % [i, x.head_pos]
	i += 1
      end
      yield(cfg)
    end

  end

  def nary2binaryL2R(tree, hf, mark = '@')
    tree.depth_first_traverse_post_order do |node|
      next if node.leaf?
      
      hid = hf.find(node.label, node.children)

      node.head = hid if node.head == nil 
      
      subtree = node.left_branch(hid) do |x|
	x.label = node.label
	x.mark = mark
	x.head = 1
	node.head -= 1
	x 
      end

      subtree = node.right_branch(0) do |x|
	x.label = node.label
	x.mark = mark
	x.head = 0
	x 
      end

      #tv.show
      #puts       

    end

    return tree
  end

  def nary2binaryR2L(tree, hf, mark = '@')
    tree.depth_first_traverse_post_order do |node|
      next if node.leaf? 

      hid = hf.find(node.label, node.children)
      node.head = hid if node.head == nil 

      subtree = node.right_branch(hid) do |x|
	x.label = node.label
	x.mark = mark
	x.head = 0
	x 
	
      end

      subtree = node.left_branch(hid) do |x|
	x.label = node.label
	x.mark = mark
	x.head = 1
	node.head -= 1
	x 
      end
    end
    return tree
  end

  def base_phrase_chunk(tree)
    tree.depth_first_traverse_pre_order do |node|
      next if node.leaf?
      is_base_phrase = true
      tag = "B"
      node.children.each do |ch|
	if ch.leaf?
	  next if tag == 'O' || node.label == "S"
	  ch.chunk = "%s-%s" % [tag, node.label]   
	  tag = "I"
	elsif tag == "I" 
	  tag = 'O'
	end
      end
    end
    return tree
  end

  def leaf_chunk(tree)
    tree.depth_first_traverse_pre_order do |node|
      # puts node.sid
      next if node.leaf?
      if node.children.size == 1 
	if node.children[0].leaf?
	  node.chunk = "I-H" 
	  node.children[0].chunk = "B"
	  if node.sid < node.children[0].sid
	    node.chunk = "B-H" 
	    node.children[0].chunk = "I"
	  end
	end
	next
      end

      lchunk = true
      node.chunk = "O"

      tmp = [] 
      tmp << node
      node.children.each do |ch|
	tmp << ch
	if ch.leaf?
	  ch.chunk = "O"
	else
	  lchunk = false
	  break 
	end

      end
      #puts node
      #puts lchunk
      next unless lchunk

      tag = "B"
      tmp.sort{|x, y| x.sid <=> y.sid}.each do |n|
      # tmp.each do |n|
	h = ''
	if n.sid == node.sid
	  # if tag == "B" ; tag = "F" ; else tag = "H" ; end
	  h = '-H'
	end
	n.chunk = "%s%s" % [tag, h]
	tag = "I" 
      end

      
    end
    return tree
  end


  def nary2binary(tree, hf, mark = '@')
    return nary2binaryR2L(tree, hf, mark = '@')
  end

  def binary2nary(tree, mark = '@')
    tree.depth_first_traverse_pre_order do |node|
      next if node.leaf?
      next if node.children.size != 2

      i = 0 
      # puts "%s => %s%s %s%s" % [node.label, node.children[i].mark, node.children[i].label, node.children[i+1].mark, node.children[i+1].label]


      while true
	lm = node.children[i].mark
	rm = node.children[i+1].mark
	
	
	#puts "!!Narize  %s => %s%s %s%s" % [node.label, lm, node.children[i].label, rm, node.children[i+1].label]

	if lm != mark && rm != mark
	  #puts "==finish"

	  #tv = TreeViewer.new(node)
	  #tv.show
	  #puts 


	  break
	elsif lm == mark && rm == mark
	  break
	  puts "<="
	  puts i 
	  #puts node.label
	  #puts node.children[i].mark
	  #puts node.children[i+1].mark
	  puts "=>"
	  
	  raise "invalid binary tree: "
	elsif lm == mark

	  ch = node.delete(i)
	  
	  ch.children.reverse.each do |c|
	    node.insert(c, i)
	  end
	  node.head = i 

	elsif rm  == mark
	  ch = node.delete(i+1)
	  ch.children.reverse.each do |c|
	    node.insert(c, i+1)
	  end
	  node.head = i+1
	  i += 1
	end
      end
    end
    return tree
  end


  def delete_child(tree)
    tree.depth_first_traverse_post_order do |node|
      next if node.leaf?

      i = 0 
      while i < node.children.size
	child = node.children[i]
	if child.pos == $OPT_e.to_s || (child.children.size == 0 && child.label != nil)
	  node.delete(i) 
	else
	  i += 1
	end
	while (node.unary? && node.label == node.children[0].label) 
	  node.delete(0).children.each do |x| 
	    node.insert(x)
	  end
	end

      end
      
    end
    return tree
  end

  def phrase2dependency(ptree)

    hash = Hash.new
    dthash = Hash.new
    dtree = nil
    # puts ptree.type
    ptree.head_first_traverse_post_order do |x|
      # puts x
      if x.leaf? 

	hash[x.id] = x 
	dt = DependencyTree.new
	dt.lex = x.lex.to_s 
	dt.lex = '-none-'if x.pos.to_s == '-NONE-'
	dt.set_pos(x.pos.to_s)
	dt.chunk = x.chunk
	dt.semantic = x.semantic
	dthash[x.id] = dt
	dtree = dt if dtree == nil 
      else
	#puts x.bracket('(', ')', ' ', false, true)
	#puts x.head
	#puts x
	hash[x.id] = hash[x.children[x.head].id]
      end
    end

    sid = 0 
    ptree.depth_first_traverse_pre_order do |x|
      if x.leaf? 
	cp = x
	label = nil 
	while hash[cp.id].id == x.id
	  label = cp.label
	  cp = cp.parent 
	end
	if cp != nil 
	  label = cp.label 
	  dthash[hash[cp.id].id].insert(dthash[x.id])  
	end
	
	dthash[x.id].label = label 
	dthash[x.id].sid = sid
	sid += 1
      end
    end


    #dtree.terminals.each do |t|
      #puts t
    #end
    #tv = TreeViewer.new(dtree)
    #tv.show   
    return dtree 
  end
  
end

if __FILE__ == $0

  require 'bracket_parser'
  require 'phrase_structure_tree'
  require 'tree_viewer'
  require 'head_finder'

  include TreeConvertor
  bp = BracketParser.new(/\(/, /\)/, PhraseStructureTree.new.type)

  def bp.pop # for format of penn treebank 
    n = super
    pp = n.delete(0)
    return pp if pp.label == nil  
    n.children.each do |ch| 
      pp.insert(ch)  
    end
    return pp 
  end

  lines = []

  line = ''

  while true
    line = $stdin.gets
    line.chomp!

    if (/^\(/ =~ line || $stdin.eof?) && lines.size != 0
      lines << line if $stdin.eof?

      tree = TreeConvertor.str2tree(lines.join(''), bp)
      break  if tree == nil 
      puts tree.bracket      

      tv = TreeViewer.new(tree)
      tv.show
      hf = HeadFinder.new
      hf.read
      tree = TreeConvertor.nary2binary(tree, hf)
      tree = TreeConvertor.binary2nary(tree)
      tv.show    
      lines.clear
    end

    if $stdin.eof
      break 
    end 
    
    next if /^[\s\t]*$/ =~ line
    lines << line    

  end

  
end

__END__
NP      right   (POS|NN|NNP|NNPS|NNS) NX JJR CD JJ JJS RB QP NP 
ADJP    right   NNS QP NN \$ ADVP JJ VBN VBG ADJP JJR NP JJS DT FW RBR RBS SBAR RB
ADVP    left    RB RBR RBS FW ADVP TO CD JJR JJ IN NP JJS NN
CONJP   left    CC RB IN
FRAG    left    .
INTJ    right   .
LST     left    LS :
NAC     right   (NN|NNS|NNP|NNPS) NP NAC EX \$ CD QP PRP VBG JJ JJS JJR ADJP FW
PP      left    IN TO VBG VBN RP FW
PRN     right   .
PRT     left    RP
QP      right   \$ IN NNS NN JJ RB DT CD NCD QP JJR JJS
RRC     left    VP NP ADVP ADJP PP
S       right   TO IN VP S SBAR ADJP UCP NP
SBAR    right   WHNP WHPP WHADVP WHADJP IN DT S SQ SINV SBAR FRAG
SBARQ   right   SQ S SINV SBARQ FRAG
SINV    right   VBZ VBD VBP VB MD VP S SINV ADJP NP
SQ      right   VBZ VBD VBP VB MD VP SQ
UCP     left    .
VP      left    VBD VBN MD VBZ VB VBG VBP VP ADJP NN NNS NP
WHADJP  right   CC WRB JJ ADJP
WHADVP  left    CC WRB
WHNP    right   WDT WP WP\$ WHADJP WHPP WHNP
WHPP    left    IN TO FW
NX      right   (POS|NN|NNP|NNPS|NNS) NX JJR CD JJ JJS RB QP NP 
