class TreeViewer < Array
  class Box

    BLANK         = '   ' 
    HORIZONTAL    = '---' 
    JOIN          = '-+ '
    VERTICAL      = ' | '

    attr_accessor :node, :branch
    def initialize
      @node = nil 
      @branch = nil
    end

    def blank
      @branch = BLANK.clone
    end
    
    def horizontal 
      @branch = HORIZONTAL.clone
    end

    def vertical
      @branch = VERTICAL.clone
    end

    def join
      @branch = JOIN.clone
    end

    def extension
      blank if @branch == nil
      @branch[@branch.size - 1] = '-'
      
    end

    def to_s(max=10)
      return (' ' * (max + 1)) + BLANK if @node == nil && @branch == nil
      
      if @node == nil 
	return (' ' * (max + 1)) + @branch  if @branch == BLANK || /\|/ =~ @branch
	return ('-' * (max + 1)) + @branch  if @branch == HORIZONTAL || /\+/ =~ @branch
	
	p @node
	p @branch 
	raise "this is " 
      end

      max = @node.size if @node.size > max
      return "%s %s%s" % [@node, '-' * (max - @node.size), @branch]
    end
  end

  def initialize(tree)
    # @root_depth = tree.max_depth
    @tree = tree
    @max_level = 0 
    @max_depth = 0 
    @num_of_leaf = 0 
    @state = []
    @check = []
    @maxlen = []

  end

  def init
    @max_level = 0 
    @max_depth = 0 
    @num_of_leaf = 0 
    self.clear
    @state.clear
    @check.clear
    @maxlen.clear
    
    @tree.depth_first_traverse_post_order do |x|
      d = x.depth 

      if x.leaf?
	@max_depth = d if @max_depth < d 
	@num_of_leaf += 1 
	@state << x 
	@state << nil
	@check << true
	@check << false
      end
    end

    #puts @max_depth 
    #puts @max_level
    #puts @tree.depth 

    @max_level = @max_depth - @tree.depth + 1

    (1 .. @num_of_leaf).each do |i|
      self << Array.new(@max_level)
      self << Array.new(@max_level)
    end

  end

  def show(os=$stdout)
    draw
    self.each do |line|
      level = 0
      line.each do |x|
	os.print x.to_s(@maxlen[level]) 
	level += 1
      end
      os.puts
    end
  end

  def draw
    init
    level = 0;    
   
    #puts "max level=%d max depth=%d" % [@max_level, @max_depth]

    while level < @max_level
      s = 0 

      within = false
      ml = 0
      # puts "--| level=%d |--" % [level]

      @state.each_index do |i|
	box = Box.new

	ns = nil 
	tmp = @check[i]
	
	cd = @max_level + 1
	#puts "%2d:check=%5s=>%5s[%5s] %s" % [i, @check[i], tmp, within, box]

	if  @state[i] == nil
	  box.blank
	  box.vertical if within

	elsif @state[i] != nil
	  
	  cd = @state[i].depth
	  box.node = @state[i].to_s if @check[i]

	  if cd  < @max_depth - level
	    # puts "state = depth < level "
	    box.horizontal
	    ns = @state[i]
	    within = false
	  elsif cd == @max_depth - level
	    # puts "state = depth == level "
	    box.join 
	    within = true
	    if @state[i].next == nil && @state[i].prev == nil
	      box.horizontal 
	      within = false
	    end

	    box.blank if @max_level == level + 1
	    ns = nil
	  else
	    #puts "state = depth > level [%s]" % [box.to_s]
	    ns = nil 
	    @check[i] = false
	  end

	  @check[i] = false
	end
	#puts "%2d:check=%5s=>%5s[%5s] %s" % [i, @check[i], tmp, within, box]
	ml = box.node.size if box.node != nil && ml < box.node.size 

	self[i][level] = box 
	#puts @state[i]
	if  @state[i] != nil
	  within = false

	  # if @state[i].root?
	  #puts "%2d:check=%5s=>%5s[%5s] %s" % [i, @check[i], tmp, within, box] 
	  
	  if  @state[i].next == nil && @state[i].prev == nil 
	    # puts "unary"
	    
	    ns = @state[i].parent 
	    @check[i] = true
	    # within = true if cd == (@max_depth - level)  &&  @max_level != level + 1 

	  elsif  @state[i].next == nil && @state[i].prev != nil 
	    m = s + ((i - s) / 2).to_i
	    if cd  == (@max_depth - level) &&  @max_level != level + 1
	      # puts "%s :: ==> extension <== s=%s m=[%s] level=%s" % [i, s, m, level,]
	      self[m][level].extension  
	      if ! (level == @max_level)
		@state[m] = @state[i].parent
		@check[m] = true 
	      end

	    end
	    within = false	    
	    

	  elsif  @state[i].next != nil && @state[i].prev == nil 
	    s = i
	    # puts "first child"

	    within = false
	    if cd == (@max_depth - level) && @max_level != level + 1
	      within = true 
	      ns = nil 
	    end
	    @check[i] = false

	  else
	    # puts "within %d %d" % [cd , (@max_depth - level)]
	    within = true if cd == (@max_depth - level)
	    
	    #ns = nil 
	    #if cd == (@max_depth - level)
	  end

	end
	
	#puts "%2d:check=%5s=>%5s[%5s] %s" % [i, @check[i], tmp, within, box]
	#puts 
	@state[i] = ns
      end

      @maxlen << ml 
      level += 1
    end
  end
end 
